VTK: vtkImplicitSum Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkImplicitSum Class Reference

implicit sum of other implicit functions More...

`#include <vtkImplicitSum.h>`

Inheritance diagram for vtkImplicitSum:
[legend]
Collaboration diagram for vtkImplicitSum:
[legend]

## Public Types
typedef vtkImplicitFunction | Superclass
Public Types inherited from vtkImplicitFunction
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkImplicitSum * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | EvaluateGradient (double x[3], double g[3]) override
| Evaluate gradient of the weighted sum of functions. More...
vtkMTimeType | GetMTime () override
| Override modified time retrieval because of object dependencies. More...
void | AddFunction (vtkImplicitFunction *in, double weight)
| Add another implicit function to the list of functions, along with a weighting factor. More...
void | AddFunction (vtkImplicitFunction *in)
| Add another implicit function to the list of functions, weighting it by a factor of 1. More...
void | RemoveAllFunctions ()
| Remove all functions from the list. More...
void | SetFunctionWeight (vtkImplicitFunction *f, double weight)
| Set the weight (coefficient) of the given function to be weight. More...
double | EvaluateFunction (double x[3]) override
| Evaluate implicit function using current functions and weights. More...
virtual double | EvaluateFunction (double x[3])=0
| Evaluate implicit function using current functions and weights. More...
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
| Evaluate implicit function using current functions and weights. More...
virtual double | EvaluateFunction (double x, double y, double z)
| Evaluate implicit function using current functions and weights. More...
virtual void | SetNormalizeByWeight (vtkTypeBool)
| When calculating the function and gradient values of the composite function, setting NormalizeByWeight on will divide the final result by the total weight of the component functions. More...
virtual vtkTypeBool | GetNormalizeByWeight ()
| When calculating the function and gradient values of the composite function, setting NormalizeByWeight on will divide the final result by the total weight of the component functions. More...
virtual void | NormalizeByWeightOn ()
| When calculating the function and gradient values of the composite function, setting NormalizeByWeight on will divide the final result by the total weight of the component functions. More...
virtual void | NormalizeByWeightOff ()
| When calculating the function and gradient values of the composite function, setting NormalizeByWeight on will divide the final result by the total weight of the component functions. More...
Public Member Functions inherited from vtkImplicitFunction
vtkImplicitFunction * | NewInstance () const
virtual void | FunctionValue (vtkDataArray *input, vtkDataArray *output)
| Evaluate function at position x-y-z and return value. More...
double | FunctionValue (const double x[3])
| Evaluate function at position x-y-z and return value. More...
double | FunctionValue (double x, double y, double z)
| Evaluate function at position x-y-z and return value. More...
void | FunctionGradient (const double x[3], double g[3])
| Evaluate function gradient at position x-y-z and pass back vector. More...
double * | FunctionGradient (const double x[3])
| Evaluate function gradient at position x-y-z and pass back vector. More...
double * | FunctionGradient (double x, double y, double z)
| Evaluate function gradient at position x-y-z and pass back vector. More...
virtual void | SetTransform (vtkAbstractTransform *)
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual void | SetTransform (const double elements[16])
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual vtkAbstractTransform * | GetTransform ()
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
| Evaluate function at position x-y-z and return value. More...
virtual double | EvaluateFunction (double x, double y, double z)
| Evaluate function at position x-y-z and return value. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkImplicitSum * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImplicitSum * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkImplicitFunction
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImplicitFunction * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkImplicitSum ()
| ~vtkImplicitSum () override
void | CalculateTotalWeight ()
Protected Member Functions inherited from vtkImplicitFunction
| vtkImplicitFunction ()
| ~vtkImplicitFunction () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkImplicitFunctionCollection * | FunctionList
vtkDoubleArray * | Weights
double | TotalWeight
vtkTypeBool | NormalizeByWeight
Protected Attributes inherited from vtkImplicitFunction
vtkAbstractTransform * | Transform
double | ReturnValue [3]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

implicit sum of other implicit functions

vtkImplicitSum produces a linear combination of other implicit functions. The contribution of each function is weighted by a scalar coefficient. The NormalizeByWeight option normalizes the output so that the scalar weights add up to 1. Note that this function gives accurate sums and gradients only if the input functions are linear.

Tests:
  vtkImplicitSum (Tests)

Definition at line 27 of file vtkImplicitSum.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkImplicitFunction vtkImplicitSum::Superclass

Definition at line 32 of file vtkImplicitSum.h.

## Constructor & Destructor Documentation

## ◆ vtkImplicitSum()

vtkImplicitSum::vtkImplicitSum | ( |  | ) |
| protected

## ◆ ~vtkImplicitSum()

vtkImplicitSum::~vtkImplicitSum | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkImplicitSum* vtkImplicitSum::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkImplicitSum::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkImplicitSum::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkImplicitFunction.

## ◆ SafeDownCast()

static vtkImplicitSum* vtkImplicitSum::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkImplicitSum::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkImplicitFunction.

## ◆ NewInstance()

vtkImplicitSum* vtkImplicitSum::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkImplicitSum::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkImplicitFunction.

## ◆ EvaluateFunction() [1/4]

double vtkImplicitSum::EvaluateFunction | ( | double | x[3] | ) |
| overridevirtual

Evaluate implicit function using current functions and weights.

Implements vtkImplicitFunction.

## ◆ EvaluateGradient()

void vtkImplicitSum::EvaluateGradient | ( | double | x[3],
|  | double | g[3]
| ) |  |
| overridevirtual

Evaluate gradient of the weighted sum of functions.

Input functions should be linear.

Implements vtkImplicitFunction.

## ◆ GetMTime()

vtkMTimeType vtkImplicitSum::GetMTime | ( |  | ) |
| overridevirtual

Override modified time retrieval because of object dependencies.

Reimplemented from vtkImplicitFunction.

## ◆ AddFunction() [1/2]

void vtkImplicitSum::AddFunction | ( | vtkImplicitFunction * | in,
|  | double | weight
| ) |  |

Add another implicit function to the list of functions, along with a weighting factor.

## ◆ AddFunction() [2/2]

void vtkImplicitSum::AddFunction | ( | vtkImplicitFunction * | in | ) |
| inline

Add another implicit function to the list of functions, weighting it by a factor of 1.

Definition at line 64 of file vtkImplicitSum.h.

## ◆ RemoveAllFunctions()

void vtkImplicitSum::RemoveAllFunctions | ( |  | ) |

Remove all functions from the list.

## ◆ SetFunctionWeight()

void vtkImplicitSum::SetFunctionWeight | ( | vtkImplicitFunction * | f,
|  | double | weight
| ) |  |

Set the weight (coefficient) of the given function to be weight.

## ◆ SetNormalizeByWeight()

virtual void vtkImplicitSum::SetNormalizeByWeight | ( | vtkTypeBool |  | ) |
| virtual

When calculating the function and gradient values of the composite function, setting NormalizeByWeight on will divide the final result by the total weight of the component functions.

This process does not otherwise normalize the gradient vector. By default, NormalizeByWeight is off.

## ◆ GetNormalizeByWeight()

virtual vtkTypeBool vtkImplicitSum::GetNormalizeByWeight | ( |  | ) |
| virtual

When calculating the function and gradient values of the composite function, setting NormalizeByWeight on will divide the final result by the total weight of the component functions.

This process does not otherwise normalize the gradient vector. By default, NormalizeByWeight is off.

## ◆ NormalizeByWeightOn()

virtual void vtkImplicitSum::NormalizeByWeightOn | ( |  | ) |
| virtual

When calculating the function and gradient values of the composite function, setting NormalizeByWeight on will divide the final result by the total weight of the component functions.

This process does not otherwise normalize the gradient vector. By default, NormalizeByWeight is off.

## ◆ NormalizeByWeightOff()

virtual void vtkImplicitSum::NormalizeByWeightOff | ( |  | ) |
| virtual

When calculating the function and gradient values of the composite function, setting NormalizeByWeight on will divide the final result by the total weight of the component functions.

This process does not otherwise normalize the gradient vector. By default, NormalizeByWeight is off.

## ◆ CalculateTotalWeight()

void vtkImplicitSum::CalculateTotalWeight | ( |  | ) |
| protected

## ◆ EvaluateFunction() [2/4]

virtual double vtkImplicitFunction::EvaluateFunction

Evaluate implicit function using current functions and weights.

## ◆ EvaluateFunction() [3/4]

virtual void vtkImplicitFunction::EvaluateFunction

Evaluate implicit function using current functions and weights.

## ◆ EvaluateFunction() [4/4]

virtual double vtkImplicitFunction::EvaluateFunction
| inline

Evaluate implicit function using current functions and weights.

Definition at line 121 of file vtkImplicitFunction.h.

## Member Data Documentation

## ◆ FunctionList

vtkImplicitFunctionCollection* vtkImplicitSum::FunctionList
| protected

Definition at line 93 of file vtkImplicitSum.h.

## ◆ Weights

vtkDoubleArray* vtkImplicitSum::Weights
| protected

Definition at line 94 of file vtkImplicitSum.h.

## ◆ TotalWeight

double vtkImplicitSum::TotalWeight
| protected

Definition at line 95 of file vtkImplicitSum.h.

## ◆ NormalizeByWeight

vtkTypeBool vtkImplicitSum::NormalizeByWeight
| protected

Definition at line 98 of file vtkImplicitSum.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkImplicitSum.h